<template>
    <div class="video h-full w-full float-left absolute left-0 top-0 z-20 ml-2 xl:relative" v-show="dialing || ringing || talking"  v-bind:class="{'bg-black': talking, 'bg-purple-100': !talking}">
        <video ref="remote" class="w-full h-full" autoplay playsinline></video>
        <div class="mirror absolute bottom-0 right-0 w-32 h-32 mb-4 mr-4 shadow-lg" v-bind:class="{'bg-black': dialing || talking, 'bg-purple-200': !(dialing || talking)}">
            <video ref="local" class="w-full h-full" autoplay playsinline></video>
        </div>
        <div class="view-actions flex flex-row justify-end h-12 w-full absolute top-0 left-0">
            <div class="xl:hidden flex-grow-0 self-center text-center text-2xl p-4 text-purple-500 hover:text-purple-600 cursor-pointer" v-on:click="$emit('minimize')">
                <i class="fas fa-comments"></i>
            </div>
            <div class="flex-grow-0 self-center text-center text-2xl p-4 text-purple-500 hover:text-purple-600 cursor-pointer">
                <i class="fas fa-compress"></i>
            </div>
        </div>
        <div class="call-actions flex flex-row justify-around h-12 w-full absolute bottom-0 left-0 mb-16">
            <div class="flex-grow-0 self-center text-center text-4xl p-4 text-white bg-green-500 hover:bg-green-600 cursor-pointer rounded-full shadow-lg" v-show="ringing" ref="accept" v-on:click="accept">
                <i class="fas fa-phone-alt"></i>
            </div>
            <div class="flex-grow-0 self-center text-center text-4xl p-4 text-white bg-orange-600 hover:bg-orange-700 cursor-pointer rounded-full shadow-lg" ref="reject" v-on:click="reject">
                <i class="fas fa-phone-slash"></i>
            </div>
        </div>
    </div>
</template>
<script>
export default {
    name: "WeePhoneComponent",
    props: [],
    data: function(){
        return {
            dialing: false,
            ringing: false,
            talking: false,
            user: {
                name: "Nobody"
            }
        }
    },
    beforeCreate: function(){
        this._on_accept = function(){}
        this._on_reject = function(){}
    },
    methods: {
        local: function(){
            return this.$refs.local;
        },
        remote: function(){
            return this.$refs.remote;
        },
        dial: function(user){
            this.user = user;
            this.dialing = true;
        },
        ring: function(user){
            this.user = user;
            this.ringing = true;
        },
        connected: function(){
            this.dialing = false;
            this.ringing = false;
            this.talking = true;
        },
        disconnected: function(){
            this.dialing = false;
            this.ringing = false;
            this.talking = false;
        },
        reset: function(){
            this.dialing = false;
            this.ringing = false;
            this.talking = false;
            this.user    = {
                name: "Nobody"
            }
        },
        accept: function(){
            this.$emit("accepted");
        },
        reject: function(){
            console.log("reject called from phone, ", this.talking);
            if(this.talking || this.dialing){
                console.log("emitting disconnect from phone");
                this.$emit("disconnect");
            }else{
                console.log("emitting rejected from phone");
                this.$emit("rejected");
            }
            this.reset();
        }
    },
    computed: {
        active: function(){
            return this.dialing || this.ringing || this.talking;
        }
    }
}
</script>
<style scoped>
 
</style>
